CREATE TABLE GALLEON_PRIVATEMESSAGES ( 
    ID          NVARCHAR2(35) NOT NULL,
    FROMUSERIDFK      NVARCHAR2(35) NOT NULL,
    TOUSERIDFK      NVARCHAR2(35) NOT NULL,
    SENT        DATE NOT NULL,
    "BODY"        NCLOB NOT NULL,    
    SUBJECT         NVARCHAR2(255) NOT NULL, 
    UNREAD              INTEGER NOT NULL
    );
    
CREATE TABLE GALLEON_CONFERENCES ( 
    ID                NVARCHAR2(35) NOT NULL,
    NAME              NVARCHAR2(255) NOT NULL,
    DESCRIPTION         NVARCHAR2(255) NOT NULL,
    ACTIVE              INTEGER NOT NULL,
    MESSAGES            INTEGER NULL,
    LASTPOST            VARCHAR2(35) NULL,
    LASTPOSTUSERIDFK    VARCHAR2(35) NULL,
    LASTPOSTCREATED     DATE NULL
    );

CREATE TABLE GALLEON_FORUMS ( 
    ID                  NVARCHAR2(35) NOT NULL,
    NAME                NVARCHAR2(255) NOT NULL,
    DESCRIPTION         NVARCHAR2(255) NOT NULL,
    ACTIVE              INTEGER NOT NULL,
    ATTACHMENTS         INTEGER NOT NULL,
    CONFERENCEIDFK      NVARCHAR2(35) NOT NULL,
    MESSAGES            INTEGER NULL,
    LASTPOST            VARCHAR2(35) NULL,
    LASTPOSTUSERIDFK    VARCHAR2(35) NULL,
    RANK         INTEGER NULL,
    LASTPOSTCREATED     DATE NULL
);

CREATE TABLE GALLEON_GROUPS ( 
    ID       NVARCHAR2(35) NOT NULL,
    "GROUP"    NVARCHAR2(50) NOT NULL 
    );
    
CREATE TABLE GALLEON_MESSAGES ( 
    ID          NVARCHAR2(35) NOT NULL,
    TITLE         NVARCHAR2(255) NOT NULL,
    "BODY"        NCLOB NOT NULL,
    POSTED        DATE NOT NULL,
    USERIDFK      NVARCHAR2(35) NOT NULL,
    THREADIDFK    NVARCHAR2(35) NOT NULL,
    ATTACHMENT    NVARCHAR2(255) NULL,
    FILENAME      NVARCHAR2(255) NULL, 
    DELETEID          NVARCHAR2(35) NULL
    );
    
CREATE TABLE GALLEON_PERMISSIONS ( 
    ID            VARCHAR2(35) NOT NULL,
    RIGHTIDFK       VARCHAR2(35) NOT NULL,
    RESOURCEIDFK    VARCHAR2(35) NOT NULL,
    GROUPIDFK       VARCHAR2(35) NOT NULL 
    );

CREATE TABLE GALLEON_THREADS ( 
    ID                VARCHAR2(35) NOT NULL,
    NAME              VARCHAR2(255) NOT NULL,
    ACTIVE              INTEGER NOT NULL,
    USERIDFK            VARCHAR2(35) NOT NULL,
    FORUMIDFK           VARCHAR2(35) NOT NULL,
    DATECREATED         DATE NOT NULL,
    STICKY              INTEGER NOT NULL,
    MESSAGES            INTEGER NULL,
    LASTPOSTUSERIDFK    VARCHAR2(35) NULL,
    LASTPOSTCREATED     DATE NULL 
    );

CREATE TABLE GALLEON_RANKS ( 
    ID          NVARCHAR2(35) NOT NULL,
    NAME        NVARCHAR2(50) NOT NULL,
    MINPOSTS      INTEGER NOT NULL 
    );

CREATE TABLE GALLEON_RIGHTS ( 
    ID       VARCHAR2(35) NOT NULL,
    RIGHT    VARCHAR2(255) NOT NULL 
    );

CREATE TABLE GALLEON_SEARCH_LOG ( 
    SEARCHTERMS     NVARCHAR2(255) NOT NULL,
    DATESEARCHED    DATE NOT NULL 
    );

CREATE TABLE GALLEON_SUBSCRIPTIONS ( 
    ID              NVARCHAR2(35) NOT NULL,
    USERIDFK          NVARCHAR2(35) NOT NULL,
    THREADIDFK        NVARCHAR2(35) NULL,
    FORUMIDFK         NVARCHAR2(35) NULL,
    CONFERENCEIDFK    NVARCHAR2(35) NULL 
    );



CREATE TABLE GALLEON_USERS_GROUPS ( 
    USERIDFK     NVARCHAR2(35) NOT NULL,
    GROUPIDFK    NVARCHAR2(35) NOT NULL 
    );

CREATE TABLE GALLEON_USERS ( 
    ID            NVARCHAR2(35) NOT NULL,
    USERNAME        NVARCHAR2(50) NOT NULL,
    PASSWORD      NVARCHAR2(50) NOT NULL,
    EMAILADDRESS    NVARCHAR2(255) NOT NULL,
    SIGNATURE       NVARCHAR2(1000) NULL,
    DATECREATED     DATE NOT NULL,
    CONFIRMED       INTEGER NOT NULL ,
    AVATAR          NVARCHAR2(255) NULL 
    );

ALTER TABLE GALLEON_CONFERENCES ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_FORUMS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_GROUPS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_MESSAGES ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_PERMISSIONS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_RANKS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_RIGHTS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_SUBSCRIPTIONS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_THREADS ADD (PRIMARY KEY (id));
ALTER TABLE GALLEON_USERS ADD (PRIMARY KEY (id));




INSERT INTO GALLEON_USERS(ID,USERNAME,PASSWORD,EMAILADDRESS,DATECREATED,CONFIRMED,SIGNATURE)
VALUES('AD0CD90E-07C8-CFFE-F80C5EB6688AF47A','admin','21232F297A57A5A743894A0E4A801FC3','admin@127.0.0.1',SYSDATE,1,'');

INSERT INTO GALLEON_GROUPS(ID,"GROUP")
VALUES('AD0EA988-0C8E-E2B3-DF0CF594C5DAAD63','forumsadmin');

INSERT INTO GALLEON_GROUPS(ID,"GROUP")
VALUES('AD0F29B5-BEED-B8BD-CAA9379711EBF168','forumsmember');

INSERT INTO GALLEON_GROUPS(ID,"GROUP")
VALUES('AD0F717C-AFE5-FD0E-77EB8FF5BDD858A2','forumsmoderator');

INSERT INTO GALLEON_USERS_GROUPS(USERIDFK,GROUPIDFK)
VALUES('AD0CD90E-07C8-CFFE-F80C5EB6688AF47A','AD0EA988-0C8E-E2B3-DF0CF594C5DAAD63');

INSERT INTO GALLEON_RIGHTS(ID,RIGHT)
  VALUES('7EA5070B-9774-E11E-96E727122408C03C', 'CanView');
  
INSERT INTO GALLEON_RIGHTS(ID, RIGHT)
  VALUES('7EA5070C-E788-7378-8930FA15EF58BBD2', 'CanPost');
  
  INSERT INTO GALLEON_RIGHTS(ID, RIGHT)
  VALUES('7EA5070D-CB58-72BA-2E4A3DFC0AE35F35', 'CanEdit');
